//b_とりゃえずリリース
//c_リクエストがあったので、選択範囲に影響がなかった場合のメッセージを変更_ついでに一瞬チカッと。
//d_機能そのままで大幅に簡潔に書き換え
//e_項目追加_リンク切れ画像、変更されている画像、画像まわりをすっきりめに書き換え

#target indesign
#targetengine "filsel"

function cp(mes){ //チェック用
//	alert(mes);
//	$.writeln(mes);
	}

dlg1=
"palette{orientation:'row' ,text:'Selection Filter_e',\
fs:Group{orientation : 'column' ,alignChildren : 'left',\
dd:DropDownList {helpTip : '対象項目を選択'},\
B:Group{orientation : 'row',\
btn1:Button{text:'抽出 (extract)',helpTip : '選択範囲（未選択ならスプレッド全体）から抽出'},\
btn2:Button{text:'除外 (exclude)' , helpTip : '選択範囲から除外'},\
},\
s:StaticText {text:'info.' , characters : 30},\
},\
}";

ddItemsB=["テキストフレーム","長方形","楕円形","多角形（複合パス、2点以外のオープンパス）","線（2点からなるオープンパス）"]; //基本
ddItemsG=["空のグラフィックフレーム","配置画像の親フレーム","配置画像", "クリッピングされた配置画像", "リンク切れの画像", "変更された画像"]; //グラヒック関連
ddItemsT=["フレームグリッド","フレームグリッドじゃないテキストフレーム","パステキスト","オーバーフローのあるテキストフレーム"]; //テケスト関連
funcAry=[
[["reflect.name==\"TextFrame\""]],
[["reflect.name==\"Rectangle\""]],
[["reflect.name==\"Oval\""]],
[["reflect.name==\"Polygon\""]],
[["reflect.name==\"GraphicLine\""]],
[],
[["contentType==ContentType.GRAPHIC_TYPE"], ["allGraphics.length==0"]],
[["reflect.name !=\"TextFrame\""], ["allGraphics.length !=0"]],
[["parent"]],
[["clippingPath.clippingType !=ClippingPathType.NONE"]],
[["itemLink.status==LinkStatus.LINK_MISSING"]], 
[["itemLink.status==LinkStatus.LINK_OUT_OF_DATE"]], 
[],
[["parentStory.storyPreferences.frameType ==FrameTypes.FRAME_GRID_TYPE"]],
[["parentStory.storyPreferences.frameType !=FrameTypes.FRAME_GRID_TYPE"]],
[["textPaths.length"]],
[["parentStory.overflows==true"]]
];


function sortIDfunc(a,b){
	return a.id-b.id;
	}

function filtG(obj){ //グループの中身を選択、ガワを非選択に
	obj.pageItems.everyItem().select(SelectionOptions.ADD_TO);
	if(obj.groups.length){
		gObj=obj.groups.everyItem();
		gObj.select(SelectionOptions.REMOVE_FROM);
		filtG(gObj);
		}
	}

function filterfunc(obj, typ, ary){
	for(var i=0; i<obj.length; i++){
		myObj=obj[i];
		checkObj=0;
		if(myObj.reflect.name=="Group"){ //グループアイテムなら中のアイテムをヨム
			filterfunc(myObj.pageItems.everyItem().getElements(), typ, ary);
			continue;
			}
		for(var j=0; j<typ.length; j++){
			try{
				myVerifyObj=eval(myObj.toSource()+"."+typ[j]);
				checkObj=(myVerifyObj)? 1 : 0 ;
				}
			catch(e){
				continue;
				}
			if( !checkObj){
				break;
				}
			}
		if(checkObj){
			ary.push(myObj);
			}
		}
	}


function fsFunc(sel){
	filsel=[], filsel2=[], filsel3=[];
	typeNameObj="";
	val=win.fs.dd.selection.index;
	if(val>=8 && val<=11){ //8-11は先に画像の親フレームをフィルタリング
		val=7;
		}
	filterfunc(sel, funcAry[val], filsel); 
	if(win.fs.dd.selection.index>=8 && val<=11){ //画像をフィルタリング
		for(i=0; i<filsel.length; i++){
			filterfunc([filsel[i].allGraphics[0]], funcAry[win.fs.dd.selection.index], filsel3); 
			}
		filsel=filsel3;
		}

	if( !filsel.length){
		win.fs.s.text="Result : ありません";
		return false;
		}
	filsel2.push(filsel.shift()); //重複アイテムの削除
	while(filsel.length){
		try{
			a=filsel.shift();
			if(filsel2[filsel2.length-1].id!=a.id){
				filsel2.push(a);
				}
			}
		catch(e){
			continue;
			}
		}
	return filsel2;
	}


win=new Window(dlg1);
win.fs.dd.size=[300,20];
for(i=0; i<ddItemsB.length; i++){
	win.fs.dd.add("item", ddItemsB[i]);
	}
win.fs.dd.add("separator");
for(i=0; i<ddItemsG.length; i++){
	win.fs.dd.add("item", ddItemsG[i]);
	}
win.fs.dd.add("separator");
for(i=0; i<ddItemsT.length; i++){
	win.fs.dd.add("item", ddItemsT[i]);
	}
win.fs.dd.selection=(0);

win.fs.B.btn1.onClick=function(){ //抽出
	win.fs.s.text="";
	doc=app.activeDocument;
	selOrg=doc.selection;
	if( ! doc.selection.length){//選択オブジェクトがない時はスプレッド全体をフィルタリング
		doc.select(SelectAll.ALL);
		}
	sel=doc.selection;
	targetObj=fsFunc(sel);
	if(targetObj==false){
		doc.selection=selOrg;
		return;
		}
	doc.selection=null;
	doc.selection=targetObj;
	win.fs.s.text="Result : "+targetObj.length+" 個のオブジェクトを抽出しました";
	}

win.fs.B.btn2.onClick=function(){ //除外
	win.fs.s.text="";
	resObj=0;
	doc=app.activeDocument;
	sel=doc.selection;
	selOrg=doc.selection;
	if( ! sel.length){
		return;
		}
	for(i=0; i<sel.length; i++){ //グループをばらす
		if(sel[i].reflect.name=="Group"){
			sel[i].select(SelectionOptions.REMOVE_FROM);
			filtG(sel[i]);
			}
		}
	sel=doc.selection;
	targetObj=fsFunc(sel);
	if(targetObj==false){
		doc.selection=selOrg;
		return;
		}
	for(i=0; i<targetObj.length; i++){
		try{
			targetObj[i].select(SelectionOptions.REMOVE_FROM);
			resObj++;
			}
		catch(e){
			continue;
			}
		}
	if(resObj){
		win.fs.s.text="Result : "+resObj+" 個のオブジェクトを除外しました";
		}
	}


win.show();
